Interface RouteInfo<R>
- Type Parameters:
R- The result
- All Superinterfaces:
AnnotationMetadataProvider, AnnotationSource
- All Known Subinterfaces:
ErrorRouteInfo<T,R>, MethodBasedRouteInfo<T, R>, StatusRouteInfo<T, R>, UriRouteInfo<T, R>
- All Known Implementing Classes:
DefaultErrorRouteInfo, DefaultRequestMatcher, DefaultRouteInfo, DefaultStatusRouteInfo, DefaultUrlRouteInfo
Common information shared between route and route match.
- Since:
- 1.0
- Author:
- Graeme Rocher
-
Field Summary
FieldsModifier and TypeFieldDescriptionThe default media type produced by routes.Fields inherited from interface AnnotationSource
EMPTY -
Method Summary
Modifier and TypeMethodDescriptiondefault booleanWhether this is consuming any content type.booleandoesConsume(@Nullable MediaType contentType) Whether the specified content type is an accepted type.booleandoesProduce(@Nullable MediaType acceptableType) Whether the route does produce any of the given types.booleandoesProduce(@Nullable Collection<MediaType> acceptableTypes) Whether the route does produce any of the given types.booleanexplicitlyConsumes(@Nullable MediaType contentType) Whether the specified content type is explicitly an accepted type.booleanexplicitlyProduces(@Nullable MediaType contentType) Whether the specified content type is explicitly a producing type.findStatus(@Nullable HttpStatus defaultStatus) Finds predefined route http status or uses default.Deprecated, for removal: This API element is subject to removal in a future version.default Argument<?> Deprecated, for removal: This API element is subject to removal in a future version.UsegetResponseBodyType()insteadThe media types able to produced by this route.Class<?> @Nullable ExecutorServicegetExecutor(@Nullable ThreadSelection threadSelection) LikegetRequestBodyType(), but excludes body arguments that may match only a part of the body (i.e.default @Nullable MessageBodyReader<?> default @Nullable MessageBodyWriter<R> The media types able to produced by this route.Argument<?> ReturnType<? extends R> booleanisAsync()booleanbooleanbooleandefault booleanIs this route recognized as imperative.booleanWhether the route permits a request body.booleandefault booleanIs the response body json formattable.booleanbooleanbooleanbooleanisVoid()booleanChecks if route is for web socket.booleandefault booleanWhether this is producing any content type.Methods inherited from interface AnnotationMetadataProvider
findAnnotation, findAnnotation, findDeclaredAnnotation, findDeclaredAnnotation, getAnnotationMetadata, getTargetAnnotationMetadata, isAnnotationPresent, isDeclaredAnnotationPresent, synthesize, synthesizeAll, synthesizeAnnotationsByType, synthesizeDeclared, synthesizeDeclared, synthesizeDeclaredAnnotationsByTypeMethods inherited from interface AnnotationSource
getAnnotation, getAnnotation, getDeclaredAnnotation, getDeclaredAnnotation, isAnnotationPresent, isDeclaredAnnotationPresent, synthesize, synthesizeDeclared
-
Field Details
-
DEFAULT_PRODUCES
-
-
Method Details
-
getMessageBodyWriter
- Returns:
- The message body writer, if any.
- Since:
- 4.0.0
-
getMessageBodyReader
- Returns:
- The message body reader. if any.
- Since:
- 4.0.0
-
getReturnType
ReturnType<? extends R> getReturnType()- Returns:
- The return type
-
getResponseBodyType
Argument<?> getResponseBodyType()- Returns:
- The argument representing the data type being produced.
-
isResponseBodyJsonFormattable
default boolean isResponseBodyJsonFormattable()Is the response body json formattable.- Returns:
- The response body.
-
getBodyType
Deprecated, for removal: This API element is subject to removal in a future version.UsegetResponseBodyType()instead- Returns:
- The response body type
-
getRequestBodyType
-
getBodyArgument
Deprecated, for removal: This API element is subject to removal in a future version.UYsegetRequestBodyType()instead- Returns:
- The argument that represents the body of the request
-
getFullRequestBodyType
LikegetRequestBodyType(), but excludes body arguments that may match only a part of the body (i.e. that have no@Bodyannotation, or where the@Bodyhas a value set).- Returns:
- The argument that represents the body
-
getDeclaringType
Class<?> getDeclaringType()- Returns:
- The declaring type of the route.
-
getProduces
-
getConsumes
-
consumesAll
default boolean consumesAll()Whether this is consuming any content type.- Returns:
- True if it is
- Since:
- 4.4.0
-
doesConsume
Whether the specified content type is an accepted type.- Parameters:
contentType- The content type- Returns:
- True if it is
-
producesAll
default boolean producesAll()Whether this is producing any content type.- Returns:
- True if it is
- Since:
- 4.3.0
-
doesProduce
Whether the route does produce any of the given types.- Parameters:
acceptableTypes- The acceptable types- Returns:
- True if it is
-
doesProduce
Whether the route does produce any of the given types.- Parameters:
acceptableType- The acceptable type- Returns:
- True if it is
-
explicitlyConsumes
Whether the specified content type is explicitly an accepted type.- Parameters:
contentType- The content type- Returns:
- True if it is
-
explicitlyProduces
Whether the specified content type is explicitly a producing type.- Parameters:
contentType- The content type- Returns:
- True if it is
- Since:
- 2.5.0
-
isSuspended
boolean isSuspended()- Returns:
- Is this route match a suspended function (Kotlin).
- Since:
- 2.0.0
-
isImperative
default boolean isImperative()Is this route recognized as imperative.- Returns:
- Is this route recognized as imperative.
- Since:
- 4.3.0
-
isReactive
boolean isReactive()- Returns:
- Is the route a reactive route.
- Since:
- 2.0.0
-
isSingleResult
boolean isSingleResult()- Returns:
- Does the route emit a single result or multiple results
- Since:
- 2.0
-
isSpecifiedSingle
boolean isSpecifiedSingle()- Returns:
- Does the route emit a single result or multiple results
- Since:
- 2.0
-
isCompletable
boolean isCompletable()- Returns:
- is the return type completable
- Since:
- 2.0
-
isAsync
boolean isAsync()- Returns:
- Is the route an async route.
- Since:
- 2.0.0
-
isAsyncOrReactive
boolean isAsyncOrReactive()- Returns:
- Is the route an async or reactive route.
- Since:
- 2.0.0
-
isVoid
boolean isVoid()- Returns:
- Does the route return void
- Since:
- 2.0.0
-
isErrorRoute
boolean isErrorRoute()- Returns:
- True if the route was called due to an error
- Since:
- 3.0.0
-
findStatus
Finds predefined route http status or uses default.- Parameters:
defaultStatus- The default status- Returns:
- The status
- Since:
- 2.5.2
-
isWebSocketRoute
boolean isWebSocketRoute()Checks if route is for web socket.- Returns:
- true if it's web socket route
- Since:
- 2.5.2
-
isPermitsRequestBody
boolean isPermitsRequestBody()Whether the route permits a request body.- Returns:
- True if the route permits a request body
- Since:
- 4.0.0
-
getExecutor
- Parameters:
threadSelection- The thread selection- Returns:
- The route executor
- Since:
- 4.0.0
-
needsRequestBody
boolean needsRequestBody()- Returns:
- true if the route needs request body to be read
- Since:
- 4.0.0
-
getRequestBodyType()instead